#!/bin/sh
#------------------------------------------------------------------------------
# /usr/local/htdocs/unimount/do_usb.sh - load usb modules
#
# Copyright (c) 2004-2010 Marcus Herleb, herleb(at)herleb(dot)de
# Copyright (c)      2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2004-01-01 mh
# Last Update:  $Id: do_usb.sh 30606 2012-04-26 16:34:35Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

case `uname -r` in
    2.2.*)
        echo "<font size="4" face="Verdana" color="#FF0000">You need kernel 2.4.x to mount an USB device!</font>""
        exit 1
        ;;
    2.4.*)
        module_list='scsi_mod usb-storage sd_mod usbcore uhci usb-uhci usb-ohci ehci-hcd'
        ;;
    2.6.*)
        module_list='scsi_mod usb-storage sd_mod usbcore uhci-hcd ohci-hcd ehci-hcd xhci'
        ;;
esac

for MNAME in ${module_list}
do
    if [ -z "`/sbin/lsmod | grep ${MNAME}`" ]
    then
        /sbin/modprobe ${MNAME}

        if [ $? -eq 0 ]
        then
            echo "<font size=\"4\" face=\"Verdana\" color=\"#008000\">${MNAME} wird geladen</font> ...</font>"
        else
            echo "<font size=\"4\" face=\"Verdana\" color=\"#FF0000\">ooops ... ${MNAME} kann nicht geladen werden!</font>" 
        fi
    else
        echo "<font size=\"4\" face=\"Verdana\" color=\"#008000\">Check ok, ben&ouml;tigtes Modul ${MNAME} <br>f&uuml;r die USB Unterst&uuml;tzung ist geladen ...</font>"
    fi
done

exit 0
