#!/bin/sh
#------------------------------------------------------------------------------
# /usr/local/htdocs/unimount/unimount.cgi - mount or dismount volumes, CDs
#                                           or shares
#
# Copyright (c) 2004-2010 Marcus Herleb, herleb(at)herleb(dot)de
# Copyright (c)      2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2004-01-01 mh
# Last Update:  $Id: unimount.cgi 30606 2012-04-26 16:34:35Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

eval "`proccgi $*`"

. /etc/config.d/mini_httpd_unimount

RTIME=20

myname=`basename $0`
tag=`date +%d.%m.%Y` 
uhr=`date +%T` 
log='/var/log/log.admin'
 
echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head>"
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="../main.css">'
echo "<meta http-equiv="expires" content="0">" 
echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"$RTIME;URL=$myname\">"
echo "<title>Mounter</title>"
echo "</head><body>"
echo "<h2>Universal Mounter</h2>"

if [ "${START_UNIMOUNT}" = "yes" ] 
then
    if [ "${UNIMOUNT_N}" = "0" -a "${UNIMOUNT_INFO}" = "no" ] 
    then 
        echo '<font size="4" face="Verdana" color="#FF0000">Es wurden keine Mount Devices definiert ...<br>'
        echo ' ... Mount-Info ist ebenfalls deaktiviert.</font>'
    fi

    if [ "${UNIMOUNT_USB}" = "yes" ]
    then
        echo

        if [ -f /var/run/unimount.usb ]
        then 
            rm /var/run/unimount.usb
        fi

        if [ -z "`/sbin/lsmod | grep usb-storage`" ]
        then
            /sbin/modprobe usb-storage

            if [ $? -eq 1 ]
            then
                ./do_usb.sh
                {
                    echo "-------------------------------------------------------------------------"
                    echo
                    echo "USB Treiber wurden durch unimount geladen  ;-)"
                    echo
                    echo "- ${tag}, ${uhr} --- unimount: ------------------------------------"
                    echo
                } >> ${log}

                echo " " > /var/run/unimount.usb
            fi
        fi
    fi
else
    echo '<font size="4" face="Verdana" color="#FF0000">Universal Mounter ist zur Zeit deaktiviert.</font>'
fi

echo '<pre>' 
echo '<table border="0" cellpadding="2" cellspacing="1" bgcolor="#000000">'

if [ "${START_UNIMOUNT}" = "yes" -a "${UNIMOUNT_N}" != "0" ]
then
    echo '  <tr bgcolor="#ffffc0">'
    echo '    <th>Name</th><th>Device/Volume</th><th>Directory</th><th>Zugriff</th><th>Type</th><th>User</th><th>Group</th><th>Status</th><th>&nbsp;</th>'
    echo '  </tr>'

    ROWCOLOR="#e9e9e9"

    idx=1
    while [ ${UNIMOUNT_N} -ge ${idx} ]
    do
        eval UNIMOUNT_ACTIVE='$UNIMOUNT_'${idx}'_ACTIVE'

        if [ "${UNIMOUNT_ACTIVE}" = "yes" ]
        then
            # active, go on ...
            eval UNIMOUNT_NAME='$UNIMOUNT_'${idx}'_NAME'
            eval UNIMOUNT_DEVICE='$UNIMOUNT_'${idx}'_DEVICE'
            eval UNIMOUNT_POINT='$UNIMOUNT_'${idx}'_POINT'
            eval UNIMOUNT_OPTION='$UNIMOUNT_'${idx}'_OPTION'
            eval UNIMOUNT_USER='$UNIMOUNT_'${idx}'_USER'
            eval UNIMOUNT_GROUP='$UNIMOUNT_'${idx}'_GROUP'
            eval UNIMOUNT_TYPE='$UNIMOUNT_'${idx}'_TYPE'

            if [ "${UNIMOUNT_TYPE}" = "smbfs" ]
            then
                eval UNIMOUNT_AUTH_USER='$UNIMOUNT_'${idx}'_AUTH_USER'
                eval UNIMOUNT_AUTH_PASS='$UNIMOUNT_'${idx}'_AUTH_PASS'
            fi
 
            if [ "${UNIMOUNT_OPTION}" = "ro" ]
            then
                UNIMOUNT_OPTION="ro"
            elif [ "${UNIMOUNT_OPTION}" = "rw" ]
            then
                UNIMOUNT_OPTION="rw"
            else
                UNIMOUNT_OPTION="???"
            fi

            if [ "${UNIMOUNT_USER}" = "" ]
            then
                UNIMOUNT_USER='root'
            fi

            if [ "${UNIMOUNT_GROUP}" = "" ]
            then
                UNIMOUNT_GROUP='root'
            fi

            if [ "${FORM_action}" = "mount" ]
            then
                if [ "${FORM_id}" = "${idx}" ]
                then
                    if [ "${UNIMOUNT_OPTION}" = "rw" ]
                    then
                        parameter="-w"
                    else
                        parameter="-r"
                    fi

                    if [ "${UNIMOUNT_OPTION}" = "???" -o "${UNIMOUNT_OPTION}" = "" ]
                    then
                        parameter=""
                    fi

                    if [ "${UNIMOUNT_TYPE}" = "" ]
                    then
                        parameter="${parameter}"
                    fi

                    if [ "${UNIMOUNT_DEVICE}" = "/dev/fd0" ]
                    then
                        parameter="${parameter} -o uid=${UNIMOUNT_USER},gid=${UNIMOUNT_GROUP}"
                    else
                        if [ "${UNIMOUNT_TYPE}" = "ext2" -o "${UNIMOUNT_TYPE}" = "ext3" -o "${UNIMOUNT_TYPE}" = "" ]
                        then
                            parameter="${parameter}"
                        else
                            parameter="${parameter} -t ${UNIMOUNT_TYPE} -o uid=${UNIMOUNT_USER},gid=${UNIMOUNT_GROUP}"
                        fi
                    fi

                    if [ "${UNIMOUNT_TYPE}" = "smbfs" ]
                    then
                        parameter="${parameter},username=${UNIMOUNT_AUTH_USER},password=${UNIMOUNT_AUTH_PASS}"
                    fi

                    if [ "${UNIMOUNT_TYPE}" = "vfat" -o "${UNIMOUNT_TYPE}" = "smbfs" ]
                    then
                        parameter="${parameter},iocharset=iso8859-1"
                    fi

                    parameter="${parameter} ${UNIMOUNT_DEVICE} ${UNIMOUNT_POINT} "

                    {
                        echo "-------------------------------------------------------------------------"
                        echo
                        echo "mount ${parameter}"
                        echo
                        echo "- ${tag}, ${uhr} --- unimount: ------------------------------------"
                        echo
                    } >> $log
                    mount ${parameter}
                fi
            fi

            if [ "${FORM_action}" = "umount" ] 
            then
                if [ "${FORM_id}" = "${idx}" ]
                then
                    {
                        echo "-------------------------------------------------------------------------"
                        echo
                        echo "umount ${UNIMOUNT_POINT}"
                        echo
                        echo "- ${tag}, ${uhr} --- unimount: ------------------------------------"
                        echo
                    } >> $log
                    umount ${UNIMOUNT_POINT}
                fi
            fi

            mount | grep ${UNIMOUNT_POINT} > /dev/null

            if [ $? -ne 0 ]
            then
                status="nicht geladen"
                action="<input type='button' value='Vol Laden' onClick=\"self.location.href='$myname?action=mount&id=${idx}'\">"
                status='nicht geladen'
                image="cross.gif"
            else
                status='geladen'
                action="<input type='button' value=' Entladen  ' onClick=\"self.location.href='$myname?action=umount&id=${idx}'\">"
                image="ongreen.gif"
            fi

            if [ "${ROWCOLOR}" = "#ffffff" ]
            then
                ROWCOLOR="#e9e9e9"
            else
                ROWCOLOR="#ffffff"
            fi

            echo "  <tr bgcolor=${ROWCOLOR}>"
            echo "    <td>${UNIMOUNT_NAME}</td><td>${UNIMOUNT_DEVICE}</td><td>${UNIMOUNT_POINT}</td><td align="center">${UNIMOUNT_OPTION}</td>"
            echo "    <td align="center">${UNIMOUNT_TYPE}</td><td align="center">${UNIMOUNT_USER}</td><td align="center">${UNIMOUNT_GROUP}</td>"
            echo "    <td align="center"><img border="0" src="${image}" title='${status}' width="20" height="20"></td>"
            echo "    <td>${action}</td>"
            echo "  </tr>"
        fi
 
        idx=`expr ${idx} + 1`
    done
fi

if [ "${UNIMOUNT_INFO}" = "yes" ]
then
    echo '  <tr bgcolor="#ffffff">'
#   echo '    <td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>'
    echo '    <td colspan="9" rowspan="1">&nbsp;</td>'
    echo '  </tr>'
    echo '  <tr bgcolor="#ffffc0"><th><b></b></th><th>Device/Volume</th><th>Gr&ouml;sse</th><th>Belegt</th><th>Verf&uuml;gbar</th><th>Belegt in %</th><th>unimount?</th><th><b>&nbsp;</b></th><th><b>&nbsp;</b></th>'
    echo '  </tr>'

    ROWCOLOR="#e9e9e9"

    /bin/df -h | grep -v "Available" | sed -e :a -e '$!N;s/\n / /;ta' -e 'P;D' | while read Filesystem Size Used Available Use2 Mounted
    do
        if [ "${ROWCOLOR}" = "#ffffff" ]
        then
            ROWCOLOR="#e9e9e9"
        else
            ROWCOLOR="#ffffff"
        fi

        echo "  <tr bgcolor=${ROWCOLOR}>"

        if [ "${Filesystem}" = "Filesystem" ]
        then
            echo
        else
            echo "    <td></td><td>${Filesystem}</td><td align="center">${Size}</td><td align="center">${Used}</td>"
            echo "    <td align="center">${Available}</td><td align="center">${Use2}</td>"

            idx=1
            unimounted=0
            while [ ${idx} -le ${UNIMOUNT_N} ]
            do
                eval active='$UNIMOUNT_'${idx}'_ACTIVE'

                if [ "${active}" = "yes" ]
                then
                    eval device='$UNIMOUNT_'${idx}'_DEVICE'

                    if [ "${Filesystem}" = "${device}" ]
                    then
                        unimounted=1
                        break
                    fi
                fi

                idx=`expr ${idx} + 1`
            done

            if [ ${unimounted} -eq 1 ]
            then
                image="ongreen.gif"
                text="durch Unimount gemountet, kann entladen werden"
            else
               image="cross.gif"
               text="ist ein Systemmount"
            fi

            echo "    <td align='center'><img border='0' src='${image}' title='${text}' width='20' height='20'></td><td>&nbsp;</td><td>&nbsp;</td>"
            echo '  </tr>'
        fi
    done
fi

echo '</table></body></html>'
exit 0
