#!/bin/sh
#-------------------------------------------------------------------------------
# /var/install/config.d/mini_httpd_unimount.sh - configuration generator script
#
# Copyright (c) 2004-2010 Marcus Herleb, herleb(at)herleb(dot)de
# Copyright (c) 2011-2012 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2011-06-09 jed
# Last Update:  $Id: mini_httpd_unimount.sh 30606 2012-04-26 16:34:35Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

# read eislib
. /var/install/include/eislib

pgmname=`basename $0`

module_name="mini_httpd_unimount"

config_file=/etc/config.d/${module_name}

mini_httpd_version="v1.0.0-5"

### load configuration ###
. ${config_file}
chmod 600 ${config_file}

#========================================================================================
# main
#========================================================================================

case "$1" in
    *)
        # generate all configuration files
        mecho
        mecho "version: ${mini_httpd_version}"

        if [ "${START_UNIMOUNT}" = "yes" ]
        then
            mecho "package enabled!"
        else
            mecho -warn "configuration has been disabled!"
        fi

        mecho "finished."
        ;;
esac

#========================================================================================
# End
#========================================================================================
exit 0
