#!/bin/sh
#------------------------------------------------------------------------------
# /var/install/dialog.d/UNIMOUNT_USER.sh
#
# Copyright (c) 2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2011-06-10  jed
# Last Update:  $Id: UNIMOUNT_USER.sh 28530 2011-06-10 15:38:42Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------

. /var/install/include/cuilib
. /var/install/include/ecelib

#----------------------------------------------------------------------------
# exec_dailog
# ece --> request to create and execute dialog
#         $p2 --> main window handle
#         $p3 --> name of config variable
#----------------------------------------------------------------------------
exec_dialog()
{
    win="$p2"

    tmpfile=/tmp/unimount_user.$$
    line=''
    uid=''
    user=''
    sellist='root,nobody,'

    # read list of users but ignore Samba groups
    cut -d: -f1,3 < /etc/passwd | grep -v ".*\$:" | sort > ${tmpfile}

    separator=''
    while read line
    do
        uid=`echo "${line}" | cut -d: -f2`

        if [ ${uid} -ge 2000 ]
        then
            # only show 'normal' users
            user=`echo "${line}" | cut -d: -f1`
            sellist="${sellist}${separator}${user}"
            separator=','
        fi
    done < ${tmpfile}

    rm -f ${tmpfile}

    ece_select_list_dlg "${win}" "User list" "${sellist}"
}

#----------------------------------------------------------------------------
# main routine
#----------------------------------------------------------------------------

cui_init
cui_run

#----------------------------------------------------------------------------
# end
#----------------------------------------------------------------------------

exit 0
